Index: trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 598)
+++ trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 600)
@@ -13,7 +13,7 @@
 #;../data/vienna/vienna-plane.x3d
 #	filename ../data/vienna/viewcells-25-sel.x3d
-#	filename ../data/atlanta/atlanta2.x3d
+	filename ../data/atlanta/atlanta2.x3d
 #	filename ../data/soda/soda.dat
-	filename ../data/soda/soda5.dat
+#	filename ../data/soda/soda5.dat
 }
 
@@ -25,5 +25,5 @@
 	type vss
 #	type rss
-	detectEmptyViewSpace true
+	detectEmptyViewSpace false
 }
 
@@ -36,5 +36,5 @@
 	loadInitialSamples  false
 	storeInitialSamples false
-	useViewSpaceBox true
+	useViewSpaceBox false
 #	testBeamSampling true
 }
@@ -176,17 +176,17 @@
 	# samples used for view cell construction
 	Construction {
-		samples 600000
-		samplesPerPass 200000
+		samples 2000000
+		samplesPerPass 500000
 	}
 
 	#number of active view cells
-	active 256
+	active 2048
 	maxStaticMemory	40
 
-	exportToFile false
+	exportToFile true
 	loadFromFile false
 
 	#type kdTree
-	type vspKdTree
+	#type vspKdTree
 	#type bspTree
 	type vspBspTree
@@ -209,10 +209,10 @@
 		maxCostRatio 0.1
 		minViewCells 1
-		avgCostMaxDeviation 0.8
-		maxMergesPerPass 500 
+		avgCostMaxDeviation 0.01
+		maxMergesPerPass 500
 		useRaysForMerge false
 		refine false
 		compress false
-		merge false
+		merge true
 	}
 
@@ -288,5 +288,5 @@
 VspBspTree {
 	Construction {
-		samples 300000
+		samples 1000000
 		epsilon 0.005
 		randomize false
@@ -301,8 +301,8 @@
 	# pvs                  = 1024
 	
-	splitPlaneStrategy 1024
+	splitPlaneStrategy 1026
 	
 	# maximal candidates for split planes
-	maxPolyCandidates 0
+	maxPolyCandidates 200
 
 	
@@ -322,18 +322,14 @@
 	Termination {
 		# parameters used for autopartition
-		minRays 		-150
+		minRays 		500
 		minPolygons 		-1
-		maxDepth		30
-		minPvs 			-10
-		#minProbability		0.0001
-		minProbability 		-1
-#		maxRayContribution	0.3
-		maxRayContribution	2.3
-#		maxCostRatio		0.9
-		maxCostRatio		3.9
+		maxDepth		25
+		minPvs 			-1
+		minProbability		0.0000001
+		maxRayContribution	0.3
+		maxCostRatio		0.9
 		missTolerance		3
-
-		
-		maxViewCells		512
+		
+		maxViewCells		30000
 		
 		# used for pvs criterium
@@ -341,14 +337,14 @@
 		
 		AxisAligned {
-			minRays 		1
+			minRays 		20000
 			maxRayContribution	9.9
 		}
 	}
 	
-	splitUseOnlyDrivingAxis true
+	splitUseOnlyDrivingAxis false
 	
 	Visualization {
 		# x3d visualization of the split planes
-		exportSplits true
+		exportSplits false
 	}
 }
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 591)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 600)
@@ -24,4 +24,5 @@
 class Beam;
 class ViewCellsTree;
+
 
 struct BspRay;
@@ -123,9 +124,9 @@
 		float GetCost() const
 		{
-#if 0
+#if 1
 			return mPvs * mProbability;
 #endif
-#if 1
-			return - mDepth;
+#if 0
+			return (float) (-mDepth); // for regular grid
 #endif
 #if 0
@@ -154,6 +155,6 @@
     };
 	
-	typedef std::priority_queue<VspBspTraversalData> VspBspTraversalStack;
-	//typedef std::stack<VspBspTraversalData> VspBspTraversalStack;
+	typedef std::priority_queue<VspBspTraversalData> VspBspTraversalQueue;
+	//typedef std::stack<VspBspTraversalData> VspBspTraversalQueue;
 
 	/** Default constructor creating an empty tree.
@@ -292,4 +293,8 @@
 
 	
+	int FindApproximateNeighbors(BspNode *n, 
+							     vector<BspLeaf *> &neighbors,
+								 const bool onlyUnmailed) const;
+
 	/** Checks if tree validity-flags are right 
 		with respect to view cell valitiy.
@@ -368,5 +373,5 @@
 		@returns new root of the subtree
 	*/
-	BspNode *Subdivide(VspBspTraversalStack &tStack, 
+	BspNode *Subdivide(VspBspTraversalQueue &tStack, 
 					   VspBspTraversalData &tData);
 
@@ -598,5 +603,5 @@
 	/** Returns estimated memory usage of tree.
 	*/
-	//float GetMemUsage(const VspBspTraversalStack &tstack) const;
+	//float GetMemUsage(const VspBspTraversalQueue &tstack) const;
 	float GetMemUsage() const;
 
@@ -633,5 +638,6 @@
 	float mTermMinAccRayLength;
 
-	
+	//HACK
+	int mTermMinPolygons;
 
 	//-- termination criteria for axis aligned split
@@ -677,4 +683,5 @@
 	int mMaxViewCells;
 	
+	ofstream  mSubdivisionStats;
 
 	// if rays should be stored in leaves
@@ -698,5 +705,9 @@
 	bool mOutOfMemory;
 	
-	
+	float mTotalCost;
+	int mSplits;
+
+	ofstream mSubdivsionStats;
+
 private:
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.cpp	(revision 590)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.cpp	(revision 600)
@@ -22,5 +22,5 @@
 	bool operator() (T v1, T v2) const
 	{
-		return (v1->GetTimeStamp() < v2->GetTimeStamp());
+		return (v1->GetMergeCost() < v2->GetMergeCost());
 	}
 };
@@ -107,5 +107,5 @@
 mValid(true),
 mParent(NULL),
-mTimeStamp(0),
+mMergeCost(0),
 mIsActive(false)
 {
@@ -119,5 +119,5 @@
 mValid(true),
 mParent(NULL),
-mTimeStamp(0),
+mMergeCost(0),
 mIsActive(false)
 {
@@ -230,13 +230,13 @@
 
 
-void ViewCell::SetTimeStamp(const int timeStamp)
-{
-	mTimeStamp = timeStamp;
-}
-
-
-int ViewCell::GetTimeStamp() const
-{
-	return mTimeStamp;
+void ViewCell::SetMergeCost(const float mergeCost)
+{
+	mMergeCost = mergeCost;
+}
+
+
+float ViewCell::GetMergeCost() const
+{
+	return mMergeCost;
 }
 
@@ -445,8 +445,8 @@
 	float variance = 0;
 	int totalPvs = 0;
-	float totalCost = 0;
+	float totalRenderCost = 0;
 
 	//-- compute statistics values of initial view cells
-	mViewCellsManager->EvaluateRenderStatistics(totalCost,
+	mViewCellsManager->EvaluateRenderStatistics(totalRenderCost,
 												mExpectedCost,
 												mDeviation,
@@ -471,5 +471,5 @@
 	Debug << "deviation: " << mDeviation << endl;
 	Debug << "avg render cost: " << mAvgRenderCost << endl;
-	Debug << "expected cost: " <<mExpectedCost << endl;
+	Debug << "expected cost: " << mExpectedCost << endl;
 
 
@@ -498,5 +498,5 @@
 
 	// frequency stats are updated
-	const int statsOut = 100;
+	const int statsOut = 1;
 
 	// passes are needed for statistics, because we don't want to record
@@ -521,6 +521,7 @@
 
 	//-- use priority queue to merge leaf pairs
-
-	while (!mMergeQueue.empty())// && (realNumActiveViewCells > mMergeMinViewCells))
+// HACK
+	//const float maxAvgCost = 350;
+	while (!mMergeQueue.empty())//NumActiveViewCells > mMergeMinViewCells))
 	{
 		//-- reset merge queue if the ratio of current expected cost / real expected cost
@@ -588,11 +589,22 @@
 		{
 			ViewCell::NewMail();
-						
+
+			//-- update statistical values
 			-- realNumActiveViewCells;
 			++ mergeStats.merged;
 			++ mergedPerPass;
 
-
-			//-- update statistical values
+			const float renderCostIncr = mc.GetRenderCost();
+			const float mergeCostIncr = mc.GetMergeCost();
+
+			totalRenderCost += renderCostIncr;
+			mDeviation += mc.GetDeviationIncr();
+			
+			
+			// merge the view cells of leaf1 and leaf2
+			int pvsDiff;
+			ViewCellInterior *mergedVc = 
+				MergeViewCells(mc.mLeftViewCell, mc.mRightViewCell, pvsDiff);
+
 
 			// total render cost and deviation has changed
@@ -600,23 +612,11 @@
 			// cost heuristics, but cannot recompute costs on each increase of the 
 			// expected cost
-
-			totalCost += mc.GetRenderCost();
-			mDeviation += mc.GetDeviationIncr();
-						
-			realExpectedCost = totalCost / (float)realNumActiveViewCells;
-			
-			const float currentMergeCost = mc.GetMergeCost();
-
-			// merge the view cells of leaf1 and leaf2
-			int pvsDiff;
-			ViewCellInterior *mergedVc = 
-				MergeViewCells(mc.mLeftViewCell, mc.mRightViewCell, pvsDiff);
-
 			totalPvs += pvsDiff;
-
-			// set timestamp
-			mergedVc->SetTimeStamp(mergeStats.merged);
-
+			realExpectedCost = totalRenderCost / (float)realNumActiveViewCells;
 			realAvgRenderCost = (float)totalPvs / (float)realNumActiveViewCells;
+	
+			// set merge cost to this node
+			mergedVc->SetMergeCost(totalRenderCost);
+
 #if VC_HISTORY
 			if (mc.mLeftViewCell->IsSibling(mc.mRightViewCell))
@@ -632,16 +632,12 @@
 					<< "#Merged\n" << mergeStats.merged << endl 
 					<< "#Viewcells\n" << realNumActiveViewCells << endl 
-					<< "#CurrentCost\n" << currentMergeCost << endl
-					<< "#RelativeCost\n" << currentMergeCost / mOverallCost << endl
-					<< "#CurrentPvs\n" << mc.GetLeftViewCell()->GetPvs().GetSize() << endl
-					<< "#MergedSiblings\n" << mergeStats.siblings << endl
-					<< "#AvgTreeDist\n" << mergeStats.AvgTreeDist() << endl
-					<< "#UsedExpectedCost\n" << mExpectedCost << endl
-					<< "#RealExpectedCost\n" << realExpectedCost << endl
-					<< "#RealAvgRenderCost\n" << realAvgRenderCost << endl
-					<< "#AvgRenderCost\n" << mAvgRenderCost << endl
-					<< "#expectedCostRatio\n" << mExpectedCost / realExpectedCost << endl
-					<< "#Deviation\n" << mDeviation / (float)realNumActiveViewCells << endl
-					<< "#TotalDeviation\n" << mDeviation<< endl;
+					<< "#RenderCostIncrease\n" << renderCostIncr << endl
+					<< "#TotalRenderCost\n" << totalRenderCost << endl
+					<< "#CurrentPvs\n" << mergedVc->GetPvs().GetSize() << endl
+					<< "#ExpectedCost\n" << realExpectedCost << endl
+					<< "#AvgRenderCost\n" << realAvgRenderCost << endl
+					<< "#Deviation\n" << mDeviation << endl
+					<< "#TotalPvs\n" << totalPvs << endl
+					<< "#PvsSizeDecrease\n" << -pvsDiff << endl;
 			}
 		}
@@ -682,6 +678,5 @@
 		}*/
 		ViewCellInterior *root = mViewCellsManager->MergeViewCells(activeViewCells);
-
-		root->SetTimeStamp(mergeStats.merged + 1);
+		root->SetMergeCost(totalRenderCost);
 		mRoot = root;
 	}
@@ -692,4 +687,11 @@
 	}
 
+
+	while (!mMergeQueue.empty())
+	{
+		mMergeQueue.pop();
+	}
+	
+	
 	// TODO delete because makes no sense here
 	mergeStats.expectedRenderCost = realExpectedCost;
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 599)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 600)
@@ -355,5 +355,5 @@
   
   void CollectViewCells(const int n) {
-	mNumMergedViewCells = n;
+	mNumActiveViewCells = n;
 	mViewCells.clear();
 	CollectViewCells();
@@ -454,6 +454,5 @@
 	float mMaxPvsRatio;
 
-	int mNumMergedViewCells;
-
+	int mNumActiveViewCells;
 	bool mCompressViewCells;
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 590)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 600)
@@ -86,5 +86,5 @@
 	//-- max cost ratio for early tree termination
 	environment->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
-
+mTermMinPolygons = 25;
 	//-- factors for bsp tree split plane heuristics
 	environment->GetFloatValue("VspBspTree.Factor.balancedRays", mBalancedRaysFactor);
@@ -116,4 +116,5 @@
 
 
+	mSubdivisionStats.open("subdivisionStats.log");
 
 
@@ -387,5 +388,5 @@
 
 // return memory usage in MB
-float VspBspTree::GetMemUsage(/*const VspBspTraversalStack &tstack*/) const
+float VspBspTree::GetMemUsage(/*const VspBspTraversalQueue &tstack*/) const
 {
 	return
@@ -402,5 +403,5 @@
 void VspBspTree::Construct(const PolygonContainer &polys, RayInfoContainer *rays)
 {
-	VspBspTraversalStack tStack;
+	VspBspTraversalQueue tQueue;
 
 	mRoot = new BspLeaf();
@@ -426,6 +427,11 @@
 		tData.mIsKdNode = false;
 
-	tStack.push(tData);
-
+	tQueue.push(tData);
+
+	mTotalCost = tData.GetCost() / mBox.GetVolume();
+
+	Debug << "total cost: " << mTotalCost << endl;
+	mSplits = 0;
+	
 	mBspStats.Start();
 	cout << "Contructing vsp bsp tree ... \n";
@@ -440,8 +446,8 @@
 	int nleaves = 500;
 
-	while (!tStack.empty())
-	{
-		tData = tStack.top();
-	    tStack.pop();		
+	while (!tQueue.empty())
+	{
+		tData = tQueue.top();
+	    tQueue.pop();		
 
 		if (0 && !mOutOfMemory)
@@ -457,5 +463,5 @@
 
 		// subdivide leaf node
-		BspNode *r = Subdivide(tStack, tData);
+		BspNode *r = Subdivide(tQueue, tData);
 
 		if (r == mRoot)
@@ -489,4 +495,7 @@
 		 (data.mProbability <= mTermMinProbability) ||
 		 (mBspStats.Leaves() >= mMaxViewCells) ||
+#if 0
+		 (((int)data.mPolygons->size() <= mTermMinPolygons) && !data.mPolygons->empty())||
+#endif
 		 (data.GetAvgRayContribution() > mTermMaxRayContribution) ||
 		 (data.mDepth >= mTermMaxDepth));
@@ -494,5 +503,5 @@
 
 
-BspNode *VspBspTree::Subdivide(VspBspTraversalStack &tStack,
+BspNode *VspBspTree::Subdivide(VspBspTraversalQueue &tQueue,
 							   VspBspTraversalData &tData)
 {
@@ -512,7 +521,19 @@
 		if (!newNode->IsLeaf()) //-- continue subdivision
 		{
+			if (1)
+			{
+				float costDecr = 
+					(tFrontData.GetCost() + tBackData.GetCost() - tData.GetCost()) / mBox.GetVolume();
+				mTotalCost += costDecr;
+
+				mSubdivisionStats 
+						<< "#Nodes\n" << ++ mSplits << endl
+						<< "#RenderCostDecrease\n" << -costDecr << endl 
+						<< "#TotalRenderCost\n" << mTotalCost << endl;
+			}
+
 			// push the children on the stack
-			tStack.push(tFrontData);
-			tStack.push(tBackData);
+			tQueue.push(tFrontData);
+			tQueue.push(tBackData);
 
 			// delete old leaf node
@@ -1341,4 +1362,5 @@
 			float oldCost, newCost;
 
+			// only render cost
 			if (1)
 			{
@@ -1346,5 +1368,5 @@
 				newCost = newRenderCost;
 			}
-			else
+			else // also considering standard deviation
 			{
 				// standard deviation is difference of back and front pvs
@@ -1361,40 +1383,4 @@
 
 			cost += mPvsFactor * newCost / oldCost;
-		}
-		else
-		{
-			//-- compute weighted sum of expected render cost and standard deviation
-			
-			//-- first compute expected render cost		
-			const float penaltyOld = EvalPvsPenalty(totalPvs, lowerPvsLimit, upperPvsLimit);
-         	const float penaltyFront = EvalPvsPenalty(pvsFront, lowerPvsLimit, upperPvsLimit);
-			const float penaltyBack = EvalPvsPenalty(pvsBack, lowerPvsLimit, upperPvsLimit);
-			
-			const float renderCostFront = penaltyFront * pFront;
-			const float renderCostBack = penaltyBack * pBack;
-
-			const float oldRenderCost = pOverall * (float)penaltyOld + Limits::Small;
-			const float newRenderCost = renderCostFront + renderCostBack;
-
-
-			//-- compute standard deviation
-			const float expectedCost = 0.5f * (renderCostBack + renderCostFront);
-
-			const float devFront = fabs(renderCostFront - expectedCost);
-			
-			const float devBack = fabs(renderCostBack - expectedCost);
-
-			const float newDev = 0.5f * (devFront + devBack);
-			const float oldDev = oldRenderCost * oldRenderCost;
-
-			const float newCost = newRenderCost * mRenderCostWeight + newDev * (1.0f - mRenderCostWeight);
-			const float oldCost = oldRenderCost * mRenderCostWeight + oldDev * (1.0f - mRenderCostWeight);
-
-			cost += mPvsFactor * newCost / oldCost;
-
-			// also try to equalize render differences between front and back pvs
-			//const float oldCost = pOverall + Limits::Small;
-			//float newCost = (float)abs(pvsFront - pvsBack);
-			
 		}
 	}
@@ -1404,6 +1390,8 @@
   		  << " frontpvs: " << pvsFront << " pFront: " << pFront
   		  << " backpvs: " << pvsBack << " pBack: " << pBack << endl << endl;
+	Debug << "cost: " << cost << endl;
 #endif
 
+	
 	// normalize cost by sum of linear factors
 	if(0)
@@ -1638,5 +1626,5 @@
 	int hits = 0;
 
-	stack<BspRayTraversalData> tStack;
+	stack<BspRayTraversalData> tQueue;
 
 	float maxt, mint;
@@ -1646,5 +1634,5 @@
 
 	Intersectable::NewMail();
-
+	ViewCell::NewMail();
 	Vector3 entp = ray.Extrap(mint);
 	Vector3 extp = ray.Extrap(maxt);
@@ -1690,5 +1678,5 @@
 
 			// push data for far child
-			tStack.push(BspRayTraversalData(farChild, extp, maxt));
+			tQueue.push(BspRayTraversalData(farChild, extp, maxt));
 
 			// find intersection of ray segment with plane
@@ -1709,5 +1697,5 @@
 
    			//-- fetch the next far child from the stack
-			if (tStack.empty())
+			if (tQueue.empty())
 				break;
 
@@ -1718,5 +1706,5 @@
 				break;
 
-			BspRayTraversalData &s = tStack.top();
+			BspRayTraversalData &s = tQueue.top();
 
 			node = s.mNode;
@@ -1724,5 +1712,5 @@
 			maxt = s.mMaxT;
 
-			tStack.pop();
+			tQueue.pop();
 		}
 	}
@@ -2204,4 +2192,96 @@
 	return (int)neighbors.size();
 }
+
+
+
+int VspBspTree::FindApproximateNeighbors(BspNode *n, vector<BspLeaf *> &neighbors,
+										 const bool onlyUnmailed) const
+{
+	stack<bspNodePair> nodeStack;
+	
+	BspNodeGeometry nodeGeom;
+	ConstructGeometry(n, nodeGeom);
+	
+	// split planes from the root to this node
+	// needed to verify that we found neighbor leaf
+	// TODO: really needed?
+	vector<Plane3> halfSpaces;
+	ExtractHalfSpaces(n, halfSpaces);
+
+
+	BspNodeGeometry *rgeom = new BspNodeGeometry();
+	ConstructGeometry(mRoot, *rgeom);
+
+	nodeStack.push(bspNodePair(mRoot, rgeom));
+
+	while (!nodeStack.empty())
+	{
+		BspNode *node = nodeStack.top().first;
+		BspNodeGeometry *geom = nodeStack.top().second;
+	
+		nodeStack.pop();
+
+		if (node->IsLeaf())
+		{
+			// test if this leaf is in valid view space
+			if (node->TreeValid() &&
+				(node != n) && 
+				(!onlyUnmailed || !node->Mailed()))
+			{
+				bool isAdjacent = true;
+
+				// neighbor was found
+				if (isAdjacent)
+				{	
+					neighbors.push_back(dynamic_cast<BspLeaf *>(node));
+				}
+			}
+		}
+		else
+		{
+			BspInterior *interior = dynamic_cast<BspInterior *>(node);
+
+			const int cf = Polygon3::ClassifyPlane(nodeGeom.mPolys,
+												   interior->GetPlane(),
+												   mEpsilon);
+			
+			BspNode *front = interior->GetFront();
+			BspNode *back = interior->GetBack();
+            
+			BspNodeGeometry *fGeom = new BspNodeGeometry();
+			BspNodeGeometry *bGeom = new BspNodeGeometry();
+
+			geom->SplitGeometry(*fGeom,
+								*bGeom,
+								interior->GetPlane(),
+								mBox,
+								mEpsilon);
+		
+			if (cf == Polygon3::FRONT_SIDE)
+			{
+				nodeStack.push(bspNodePair(interior->GetFront(), fGeom));
+				DEL_PTR(bGeom);
+			}
+			else
+			{
+				if (cf == Polygon3::BACK_SIDE)
+				{
+					nodeStack.push(bspNodePair(interior->GetBack(), bGeom));
+					DEL_PTR(fGeom);
+				}
+				else
+				{	// random decision
+					nodeStack.push(bspNodePair(front, fGeom));
+					nodeStack.push(bspNodePair(back, bGeom));
+				}
+			}
+		}
+	
+		DEL_PTR(geom);
+	}
+
+	return (int)neighbors.size();
+}
+
 
 
@@ -2378,9 +2458,10 @@
 {
 	int hits = 0;
-	stack<BspRayTraversalData> tStack;
+	stack<BspRayTraversalData> tQueue;
 
 	float mint = 0.0f, maxt = 1.0f;
 
 	Intersectable::NewMail();
+	ViewCell::NewMail();
 
 	Vector3 entp = origin;
@@ -2431,5 +2512,5 @@
 
 			// push data for far child
-			tStack.push(BspRayTraversalData(farChild, extp));
+			tQueue.push(BspRayTraversalData(farChild, extp));
 
 			// find intersection of ray segment with plane
@@ -2450,15 +2531,15 @@
 
 			//-- fetch the next far child from the stack
-			if (tStack.empty())
+			if (tQueue.empty())
 				break;
 
 			entp = extp;
 			
-			BspRayTraversalData &s = tStack.top();
+			BspRayTraversalData &s = tQueue.top();
 
 			node = s.mNode;
 			extp = s.mExitPoint;
 
-			tStack.pop();
+			tQueue.pop();
 		}
 	}
@@ -2711,5 +2792,5 @@
 		vector<BspLeaf *> neighbors;
 		FindNeighbors(leaf, neighbors, true);
-
+		//FindApproximateNeighbors(leaf, neighbors, true);
 		vector<BspLeaf *>::const_iterator nit, nit_end = neighbors.end();
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 590)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 600)
@@ -414,5 +414,5 @@
 		<< maxCostNodes * 100 / (double)Leaves() << endl;
 
-	app << "#N_PMINPROBABILITYAREALEAVES  ( Percentage of leaves with mininum probability )\n"
+	app << "#N_PMINPROBABILITYLEAVES  ( Percentage of leaves with mininum probability )\n"
 		<< minProbabilityNodes * 100 / (double)Leaves() << endl;
 
@@ -864,4 +864,5 @@
 }
 
+
 bool BspTree::TerminationCriteriaMet(const BspTraversalData &data) const
 {
@@ -875,4 +876,5 @@
 		 (data.GetAvgRayContribution() > mTermMaxRayContribution));
 }
+
 
 BspNode *BspTree::Subdivide(BspTraversalStack &tStack, BspTraversalData &tData)
@@ -1986,4 +1988,5 @@
 
 	Intersectable::NewMail();
+	ViewCell::NewMail();
 
 	Vector3 entp = origin;
@@ -2229,5 +2232,5 @@
 {
 	ViewCellContainer leaves;
-	mViewCellsManager->GetViewCellsTree()->CollectLeaves(vc, leaves);
+	mViewCellsTree->CollectLeaves(vc, leaves);
 
 	ViewCellContainer::const_iterator it, it_end = leaves.end();
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.h	(revision 590)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCell.h	(revision 600)
@@ -169,6 +169,6 @@
 
 
-	void SetTimeStamp(const int timeStamp);
-	int GetTimeStamp() const;
+	void SetMergeCost(const float mergeCost);
+	float GetMergeCost() const;
 	static void NewMail(const int reserve = 1) {
 		sMailId += sReservedMailboxes;
@@ -201,5 +201,5 @@
 	float mArea;
 
-	int mTimeStamp;
+	float mMergeCost;
 
 	bool mValid;
@@ -265,4 +265,5 @@
 class ViewCellsTree
 {
+	friend class ViewCellsManager;
 public:
 	ViewCellsTree(ViewCellsManager *vcm);
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 598)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 600)
@@ -77,5 +77,5 @@
     int hits = 0;
   static Ray ray;
-  AxisAlignedBox3 box = mKdTree->GetBox();
+  AxisAlignedBox3 box =  mViewSpaceBox ? *mViewSpaceBox : mKdTree->GetBox();
 
   AxisAlignedBox3 sbox = box;
@@ -203,24 +203,28 @@
 {
   Vector3 point;
-  if (!use2dSampling) {
-	if (0) {
-	  Vector3 normal;
-	  int i = Random((int)mObjects.size());
-	  Intersectable *object = mObjects[i];
-	  object->GetRandomSurfacePoint(point, normal);
-	} else
-	  point = mKdTree->GetBox().GetRandomPoint();
+  if (!use2dSampling) 
+  {
+	  if (0) 
+	  {
+		  Vector3 normal;
+		  int i = Random((int)mObjects.size());
+		  Intersectable *object = mObjects[i];
+		  object->GetRandomSurfacePoint(point, normal);
+	  } 
+	  else
+		  point = mKdTree->GetBox().GetRandomPoint();
 	//	  point = viewpoint + UniformRandomVector();
-
-  } else {
-	AxisAlignedBox3 box;
-
-	if (viewSpaceBox)
-	  box =*viewSpaceBox;
-	else
-	  box = mKdTree->GetBox();
-
-	point = box.GetRandomPoint();
-	point.y = viewpoint.y;
+  } 
+  else 
+  {
+	  AxisAlignedBox3 box;
+
+	  if (viewSpaceBox)
+		  box =*viewSpaceBox;
+	  else
+		  box = mKdTree->GetBox();
+
+	  point = box.GetRandomPoint();
+	  point.y = viewpoint.y;
   }
 
@@ -528,5 +532,5 @@
   {
 	  if (0)
-		mViewSpaceBox = box;
+		  mViewSpaceBox = box;
 	  else
 	  {
@@ -536,5 +540,5 @@
 		Vector3 size = mViewSpaceBox->Size();
 		//size[1] *= 1.25;
-		Vector3 enlarge(size[0] * 0.1f, size[1] * 0.0f, size[2] * 0.1);
+		Vector3 enlarge(size[0] * 0.25f, size[1] * 0.0f, size[2] * 0.25f);
 
 		mViewSpaceBox->Enlarge(enlarge);
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 598)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 600)
@@ -58,5 +58,5 @@
 	
 	
-	environment->GetIntValue("ViewCells.active", mNumMergedViewCells);
+	environment->GetIntValue("ViewCells.active", mNumActiveViewCells);
 	environment->GetBoolValue("ViewCells.PostProcess.compress", mCompressViewCells);
 	environment->GetBoolValue("ViewCells.Visualization.useCuttingPlane", mUseCuttingPlaneForViz);
@@ -178,4 +178,5 @@
 				 		Preprocessor::SPATIAL_BOX_BASED_DISTRIBUTION;
 
+		if (0)
 		dirSamples = !dirSamples; // toggle sampling method
 		numSamples += CastPassSamples(mSamplesPerPass, 
@@ -692,5 +693,5 @@
 	int axis = 0;
 
-	const float factor = 0.55;
+	const float factor = 0.35;
 	Vector3 point = mViewSpaceBox.Min() +  mViewSpaceBox.Size() * factor;
 
@@ -1032,13 +1033,16 @@
 		if (exporter)
 		{
+			
+			if (0 && mExportRays)
+				exporter->ExportRays(rays, RgbColor(1, 1, 1));
+
+			
+			if (mExportGeometry)
+				exporter->ExportGeometry(objects);
+
 			//exporter->SetWireframe();
 			exporter->SetFilled();
 			ExportViewCellsForViz(exporter);
 
-			if (0 && mExportRays)
-				exporter->ExportRays(rays, RgbColor(1, 1, 1));
-
-			if (mExportGeometry)
-				exporter->ExportGeometry(objects);
 
 			delete exporter;
@@ -1063,5 +1067,5 @@
 		// we can use the view cells tree hierarchy to get the right set
 		mViewCellsTree->CollectBestViewCellSet(mViewCells, 
-											   mNumMergedViewCells);
+											   mNumActiveViewCells);
 	}
 }
@@ -1113,4 +1117,5 @@
 
 	//-- post processing of bsp view cells
+
     int vcSize = 0;
 	int pvsSize = 0;
@@ -1124,31 +1129,4 @@
 
     Debug << ss << endl;
-
-	if (1) // export view cells
-	{
-		cout << "exporting initial view cells (=leaves) ... ";
-		Exporter *exporter = Exporter::GetExporter("view_cells.x3d");
-
-		if (exporter)
-		{
-			//exporter->SetWireframe();
-			exporter->SetFilled();
-			ExportViewCellsForViz(exporter);
-
-			if (mExportGeometry)
-			{
-				Material m;
-				m.mDiffuseColor = RgbColor(0, 1, 0);
-				exporter->SetForcedMaterial(m);
-			
-				exporter->SetWireframe();
-
-				exporter->ExportGeometry(objects);
-			}
-
-			delete exporter;
-		}
-		cout << "finished" << endl;
-	}
 
 	
@@ -1177,12 +1155,65 @@
 	}
 
-	// reset view cells and stats
+    // reset view cells and stats
 	ResetViewCells();
+
+	int savedColorCode  = mColorCode;
+
+	//BspLeaf::NewMail();
+	if (1) // export merged view cells
+	{
+		mColorCode = 0;
+		cout << "reseting view cells ... ";
+		ResetViewCells();
+		cout << "finished" << endl;
+
+		Exporter *exporter = Exporter::GetExporter("merged_view_cells.x3d");
+		Debug << "\nView cells after merge:\n" << mViewCellsStats << endl;
+
+		cout << "exporting view cells after merge ... ";
+
+		if (exporter)
+		{
+			if (mExportGeometry)
+				exporter->ExportGeometry(objects);
+
+			//exporter->SetWireframe();
+			exporter->SetFilled();
+			ExportViewCellsForViz(exporter);
+
+
+			delete exporter;
+		}
+		cout << "finished" << endl;
+	}
+
+	if (1) // export merged view cells
+	{
+		mColorCode = 1;
+
+		Exporter *exporter = Exporter::GetExporter("merged_view_cells_pvs.x3d");
+	
+		cout << "exporting view cells after merge (pvs size) ... ";	
+
+		if (exporter)
+		{
+			//exporter->SetWireframe();
+			
+			if (mExportGeometry)
+				exporter->ExportGeometry(objects);
+
+			//exporter->SetWireframe();
+			exporter->SetFilled();
+			ExportViewCellsForViz(exporter);
+
+			delete exporter;
+		}
+		cout << "finished" << endl;
+	}
+
+	mColorCode = savedColorCode;
+
 	FinalizeViewCells(true);
 	
-	// HACK: removes view cells in bsp leaves with active ones
-	if (0)
-		AddCurrentViewCellsToHierarchy();
-
 	// write view cells to disc
 	if (mExportViewCells)
@@ -1216,41 +1247,33 @@
 		return;
 	
-	//BspLeaf::NewMail();
-	if (1) // export merged view cells
-	{
-
-		cout << "reseting view cells ... ";
-		ResetViewCells();
-
+	int savedColorCode = mColorCode;
+
+	
+	
+	if (1) // export final view cells
+	{
+		mColorCode = 1;
+
+		Exporter *exporter = Exporter::GetExporter("final_view_cells.x3d");
+	
+		cout << "exporting view cells after merge (pvs size) ... ";	
+
+		if (exporter)
+		{
+			//exporter->SetWireframe();
+			
+			if (mExportGeometry)
+				exporter->ExportGeometry(objects);
+
+			//exporter->SetWireframe();
+			exporter->SetFilled();
+			ExportViewCellsForViz(exporter);
+
+			delete exporter;
+		}
 		cout << "finished" << endl;
-
-		Exporter *exporter = Exporter::GetExporter("merged_view_cells.x3d");
-		Debug << "\nView cells after merge:\n" << mViewCellsStats << endl;
-
-		cout << "exporting view cells after merge ... ";
-
-		if (exporter)
-		{
-			if (0)
-				exporter->SetWireframe();
-			else
-				exporter->SetFilled();
-
-			ExportViewCellsForViz(exporter);
-
-			if (mExportGeometry)
-			{
-				Material m;
-				m.mDiffuseColor = RgbColor(0, 1, 0);
-				exporter->SetForcedMaterial(m);
-				exporter->SetFilled();
-
-				exporter->ExportGeometry(objects);
-			}
-
-			delete exporter;
-		}
-		cout << "finished" << endl;
-	}
+	}
+
+	mColorCode = savedColorCode;
 
 	//-- visualization of the BSP splits
@@ -1265,4 +1288,5 @@
 	}
 
+	// export single view cells
 	ExportBspPvs(objects);
 }
